=== python-bareos/debian/control ===
Source: python-bareos
Maintainer: Bareos Team <packager@bareos.com>
Section: python
Priority: optional
Build-Depends: dh-python, debhelper (>= 7.4.3), python-all (>= 2.6.6-3), python-setuptools (>= 0.6b3), python3-all, python3-setuptools
Standards-Version: 3.9.1

Package: python-bareos
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Description: Backup Archiving REcovery Open Sourced - python module (Python 2)
 This packages contains a python module to interact with a Bareos backup system.
 It also includes some tools based on this module.

Package: python3-bareos
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Description: Backup Archiving REcovery Open Sourced - python module (Python 3)
 This packages contains a python module to interact with a Bareos backup system.
 It also includes some tools based on this module.
